#include <stdlib.h>
#include <stdio.h>

enum piss { up=1, right=2, down=3, left=4 };

struct linked_piss {
	enum piss pi;
	struct linked_piss *ss;
};
 
int moves[5][2] = {
	{0, 0},
	{0, -1},
	{1, 0},
	{0, 1},
	{-1, 0}
};

typedef int piss_grid[100];

int piss_tile(piss_grid g, int x, int y) {
	if (x < 0 || y < 0 || x > 9 || y > 9)
		return 1;
	else
		return g[(10 * y) + x];
}
void disp_grid(piss_grid g) {
	for (int i = 0; i < 100; i++) {
		if (g[i] == 1) printf("#");
		else if (g[i] == 2) printf("*");
		else printf(" ");
		if (i % 10 == 9) printf("\n");
	}
	printf("\n");
}

int *to_result(const struct linked_piss *p) {
	// Prepare for ubq analysis
	int *final_piss = malloc(500);
	for (int i = 0; p != NULL; (p = p->ss) && (i++)) {
		final_piss[i] = p->pi;
	}
	
	return final_piss;
}

struct linked_piss *attempt(piss_grid g, int ix, int iy, enum piss m, int c) {
	int x = ix + moves[m][0];
	int y = iy + moves[m][1];

	// It is not possible to go in walls
	if (piss_tile(g, x, y) == 1 || c > 500) return NULL;
	if (x == 9 && y == 9) {
		struct linked_piss *p = malloc(sizeof(struct linked_piss));
		struct linked_piss empty = {0};
		*p = empty;
		return p;
	}
	/*
	g[(10 * y) + x] = 2;
	disp_grid(g);
	*/
	// Let's check all of the directions
	for (int i = 1; i <= 4; i++) {
		if (x + moves[i][0] == ix && y + moves[i][1] == iy) continue;
		// Recursive recursion
		struct linked_piss *guess = attempt(g, x, y, i, c + 1);
		if (guess != NULL) {
			struct linked_piss *p = malloc(sizeof(struct linked_piss));
			struct linked_piss new = {i, guess}; 
			*p = new;
			return p;
		}
	}

	return NULL;
}

int *entry(piss_grid g) {
	int x = 0;
	int y = 0;

	struct linked_piss *p = attempt(g, 0, 0, 0, 0); 
	if (p != NULL)
		return to_result(p);
	else
		return NULL;
}

// We will free() nothing!
